
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class NonconformancesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.create(
            {
                id: data.id || undefined,
        
        ncr_number: data.ncr_number
        ||
        null
            ,
            
        severity: data.severity
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        root_cause: data.root_cause
        ||
        null
            ,
            
        corrective_action: data.corrective_action
        ||
        null
            ,
            
        due_at: data.due_at
        ||
        null
            ,
            
        closed_at: data.closed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await nonconformances.setInspection( data.inspection || null, {
            transaction,
        });
        
        await nonconformances.setOwner( data.owner || null, {
            transaction,
        });
        
        await nonconformances.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.nonconformances.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: nonconformances.id,
            },
            data.attachments,
            options,
        );
        

        return nonconformances;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const nonconformancesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                ncr_number: item.ncr_number
            ||
            null
            ,
            
                severity: item.severity
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                root_cause: item.root_cause
            ||
            null
            ,
            
                corrective_action: item.corrective_action
            ||
            null
            ,
            
                due_at: item.due_at
            ||
            null
            ,
            
                closed_at: item.closed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const nonconformances = await db.nonconformances.bulkCreate(nonconformancesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < nonconformances.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.nonconformances.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: nonconformances[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return nonconformances;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const nonconformances = await db.nonconformances.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.ncr_number !== undefined) updatePayload.ncr_number = data.ncr_number;
        
        
        if (data.severity !== undefined) updatePayload.severity = data.severity;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.root_cause !== undefined) updatePayload.root_cause = data.root_cause;
        
        
        if (data.corrective_action !== undefined) updatePayload.corrective_action = data.corrective_action;
        
        
        if (data.due_at !== undefined) updatePayload.due_at = data.due_at;
        
        
        if (data.closed_at !== undefined) updatePayload.closed_at = data.closed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await nonconformances.update(updatePayload, {transaction});

        
        
        if (data.inspection !== undefined) {
            await nonconformances.setInspection(
              
              data.inspection,
              
              { transaction }
            );
        }
        
        if (data.owner !== undefined) {
            await nonconformances.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await nonconformances.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.nonconformances.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: nonconformances.id,
            },
            data.attachments,
            options,
        );
        

        return nonconformances;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of nonconformances) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of nonconformances) {
                await record.destroy({transaction});
            }
        });


        return nonconformances;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findByPk(id, options);

        await nonconformances.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await nonconformances.destroy({
            transaction
        });

        return nonconformances;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findOne(
            { where },
            { transaction },
        );

        if (!nonconformances) {
            return nonconformances;
        }

        const output = nonconformances.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.inspection = await nonconformances.getInspection({
            transaction
        });
        
        
        output.owner = await nonconformances.getOwner({
            transaction
        });
        
        
        output.attachments = await nonconformances.getAttachments({
            transaction
        });
        
        
        output.organizations = await nonconformances.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.quality_inspections,
        as: 'inspection',
        
        where: filter.inspection ? {
          [Op.or]: [
            { id: { [Op.in]: filter.inspection.split('|').map(term => Utils.uuid(term)) } },
            {
              inspection_number: {
                [Op.or]: filter.inspection.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.ncr_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'ncr_number',
                        filter.ncr_number,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.root_cause) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'root_cause',
                        filter.root_cause,
                    ),
                };
            }
            
            if (filter.corrective_action) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'corrective_action',
                        filter.corrective_action,
                    ),
                };
            }
            

            
            

            
            if (filter.due_atRange) {
                const [start, end] = filter.due_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    due_at: {
                    ...where.due_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.closed_atRange) {
                const [start, end] = filter.closed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    closed_at: {
                    ...where.closed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.severity) {
                where = {
                    ...where,
                severity: filter.severity,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.nonconformances.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'nonconformances',
                        'ncr_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.nonconformances.findAll({
            attributes: [ 'id', 'ncr_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['ncr_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.ncr_number,
        }));
    }

    
};

